/*
 * MainForm.java
 *
 * Created on November 13, 2007, 3:40 PM
 */

package checkpolicy.main;

import checkpolicy.*;
import spox.policy.*;

import java.io.File;
import javax.swing.*;
import javax.swing.filechooser.*;

/**
 *
 * @author  Micah Jones
 */
public class MainForm extends javax.swing.JFrame {
    
    // Form variables
    JFileChooser fileChooser = new JFileChooser();
    
    // File filters
    FileFilter programFileFilter = new FileFilter()
    {
        public boolean accept(File f)
        {
            if (f.isDirectory())
                return true;
            if (f.getName().endsWith(".jar"))
                return true;
            return false;
        }
        public String getDescription() { return "JAR Files (*.jar)"; }
    };
    FileFilter policyFileFilter = new FileFilter()
    {
        public boolean accept(File f)
        {
            if (f.isDirectory())
                return true;
            if (f.getName().endsWith(".xml"))
                return true;
            return false;
        }
        public String getDescription() { return "Policy Files (*.xml)"; }
    };
    
    /** Creates new form MainForm */
    public MainForm() {
        initComponents();
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel2 = new javax.swing.JLabel();
        policyTextField = new javax.swing.JTextField();
        policyFileChooserButton = new javax.swing.JButton();
        rewriteButton = new javax.swing.JButton();
        mainMenuBar = new javax.swing.JMenuBar();
        fileMenu = new javax.swing.JMenu();
        exitMenuItem = new javax.swing.JMenuItem();
        helpMenu = new javax.swing.JMenu();
        aboutMenuItem = new javax.swing.JMenuItem();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Rewriter");
        setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        setLocationByPlatform(true);
        setResizable(false);

        jLabel2.setFont(new java.awt.Font("Tahoma", 0, 12));
        jLabel2.setText("Policy:");

        policyFileChooserButton.setText("...");
        policyFileChooserButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                policyFileChooserButtonActionPerformed(evt);
            }
        });

        rewriteButton.setText("Check Policy");
        rewriteButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                checkPolicyButtonActionPerformed(evt);
            }
        });

        fileMenu.setMnemonic('f');
        fileMenu.setText("File");

        exitMenuItem.setMnemonic('e');
        exitMenuItem.setText("Exit");
        exitMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                exitMenuItemActionPerformed(evt);
            }
        });
        fileMenu.add(exitMenuItem);

        mainMenuBar.add(fileMenu);

        helpMenu.setMnemonic('h');
        helpMenu.setText("Help");

        aboutMenuItem.setMnemonic('a');
        aboutMenuItem.setText("About");
        aboutMenuItem.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                aboutMenuItemActionPerformed(evt);
            }
        });
        helpMenu.add(aboutMenuItem);

        mainMenuBar.add(helpMenu);

        setJMenuBar(mainMenuBar);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(policyTextField, javax.swing.GroupLayout.PREFERRED_SIZE, 209, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(policyFileChooserButton, javax.swing.GroupLayout.PREFERRED_SIZE, 23, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 97, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(rewriteButton)
                        .addGap(88, 88, 88)))
                .addContainerGap(18, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(21, 21, 21)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(policyTextField, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(policyFileChooserButton))
                .addGap(14, 14, 14)
                .addComponent(rewriteButton)
                .addContainerGap(22, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void checkPolicyButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_checkPolicyButtonActionPerformed

    Main.checkPolicy(policyTextField.getText());

}//GEN-LAST:event_checkPolicyButtonActionPerformed

    private void aboutMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_aboutMenuItemActionPerformed
        JOptionPane.showMessageDialog(this,
                "Created by Micah Jones on 11-15-07", "About",
                JOptionPane.INFORMATION_MESSAGE);
    }//GEN-LAST:event_aboutMenuItemActionPerformed

    private void policyFileChooserButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_policyFileChooserButtonActionPerformed
        // Default to viewing "*.pol" files
        fileChooser.resetChoosableFileFilters();
        fileChooser.addChoosableFileFilter(policyFileFilter);
        // Show the open file dialog and check what was returned
        fileChooser.setLocation(this.getLocation());
        int returnVal = fileChooser.showOpenDialog(this);
        // If it's an OK, copy the file to the text box
        if (returnVal == fileChooser.APPROVE_OPTION)
            policyTextField.setText(fileChooser.getSelectedFile().getPath());
    }//GEN-LAST:event_policyFileChooserButtonActionPerformed

    private void exitMenuItemActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_exitMenuItemActionPerformed
        // Exit the program
        System.exit(0);
    }//GEN-LAST:event_exitMenuItemActionPerformed
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new MainForm().setVisible(true);
            }
        });
    }
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JMenuItem aboutMenuItem;
    private javax.swing.JMenuItem exitMenuItem;
    private javax.swing.JMenu fileMenu;
    private javax.swing.JMenu helpMenu;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JMenuBar mainMenuBar;
    private javax.swing.JButton policyFileChooserButton;
    private javax.swing.JTextField policyTextField;
    private javax.swing.JButton rewriteButton;
    // End of variables declaration//GEN-END:variables
    
}
